% $Id: IntegrateTest.oz,v 1.2 2011/10/31 00:51:32 leavens Exp $
\insert 'Integrate.oz'
\insert 'FloatTesting.oz'
declare
fun {Int F X1 X2} % Integrate with fixed Epsilon, to avoid redundancy in tests
   {Integrate F X1 X2 StandardTolerance/2.0}
end
{StartTesting 'IntegrateTest $Revision: 1.2 $'}
% Expected results from Wolfram Alpha (http://www.wolframalpha.com)
{WithinTest {Integrate fun {$ X} X end 0.0 20.0 1.0e~5} '~=~' 200.0}
{WithinTest {Integrate fun {$ X} X end ~1.0 1.0 1.0e~5} '~=~' 0.0}
{WithinTest {Int fun {$ X} ~X end 3.0 4.0} '~=~' ~3.5}
{WithinTest {Integrate fun {$ X} X*X end 0.0 0.5 1.0e~7} '~=~' 0.04166667}
{WithinTest {Integrate Cos 0.0 3.141592653589793 1.0e~19} '~=~' 1.96193e~16}
{WithinTest {Int Sin 0.0 1.0} '~=~' 0.459698}
{WithinTest {Int fun {$ X} {Cos {Sin X}} + 3.0*X*X end 0.0 0.5}
 '~=~' 0.605414}
{WithinTest {Int fun {$ X} {Cos {Sin X*X}} end ~0.5 0.5} '~=~' 0.993839}
{WithinTest {Integrate fun {$ X} {Pow X 33.0} end 0.4 0.45 1.0e~19}
 '~=~' 4.6747220817552974e~14}
{WithinTest {Int fun {$ X} {Log X} end 0.1 0.25} '~=~' ~0.266315}
{WithinTest {Int fun {$ X} {Sqrt 1.0+4.0*X} end 0.0 0.25} '~=~' 0.304738}
{DoneTesting}
